/***************************************************************************
*   Copyright (C) 2004 by Rick L. Vinyard, Jr.                            *
*   rvinyard@cs.nmsu.edu                                                  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU Lesser General Public License as        *
*   published by the Free Software Foundation version 2.1.                *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU Lesser General Public      *
*   License along with this library; if not, write to the                 *
*   Free Software Foundation, Inc.,                                       *
*   51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA              *
***************************************************************************/
#ifndef PAPYRUSGTKANIMATORFRAMEINTERVALWIDGET_H
#define PAPYRUSGTKANIMATORFRAMEINTERVALWIDGET_H

#include <set>

#include <gtkmm/adjustment.h>
#include <gtkmm/box.h>
#include <gtkmm/spinbutton.h>
#include <gtkmm/label.h>

#include <papyrus/animator.h>

namespace PapyrusGtk {

/**
 * @author Rick L Vinyard Jr <rvinyard@cs.nmsu.edu>
 */
class AnimatorFrameIntervalWidget : public Gtk::HBox
{
public:
  typedef std::set<Papyrus::Animator*> Animators;

  AnimatorFrameIntervalWidget();

    ~AnimatorFrameIntervalWidget();

    Gtk::Label& label();

    Gtk::SpinButton& spinbutton();

    Gtk::Adjustment& spinadjustment();

    void add(Papyrus::Animator& animator);

    void remove(Papyrus::Animator& animator);

    Animators& animators();

  protected:
    Animators m_animators;
    Gtk::Label m_label;
    Gtk::Adjustment m_spinadjustment;
    Gtk::SpinButton m_spinbutton;

    void on_spinbutton_value_changed();
};

}

#endif
